/*
 * Copyright 2009 Arne Vajh�j.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package dk.vajhoej.isam;

import java.util.ArrayList;
import java.util.List;

import dk.vajhoej.record.RecordException;

/**
 * Utility class to find all matching records.
 */
public class Util {
    public static <T,TK extends Comparable<TK>> List<T> findAllGE(IsamSource isam, Class<T> t, Key<TK> k) throws IsamException, RecordException {
        List<T> res = new ArrayList<T>();
        IsamResult<T> isamres = isam.readGE(t, k);
        while(isamres.read()) {
            res.add(isamres.current());
        }
        isamres.close();
        return res;
    }
    public static <T,TK extends Comparable<TK>> List<T> findAllGT(IsamSource isam, Class<T> t, Key<TK> k) throws IsamException, RecordException {
        List<T> res = new ArrayList<T>();
        IsamResult<T> isamres = isam.readGT(t, k);
        while(isamres.read()) {
            res.add(isamres.current());
        }
        isamres.close();
        return res;
    }
    public static <T,TK extends Comparable<TK>> List<T> findAllLE(IsamSource isam, Class<T> t, Key<TK> k) throws IsamException, RecordException {
        List<T> res = new ArrayList<T>();
        IsamResult<T> isamres = isam.readLE(t, k);
        while(isamres.read()) {
            res.add(isamres.current());
        }
        isamres.close();
        return res;
    }
    public static <T,TK extends Comparable<TK>> List<T> findAllLT(IsamSource isam, Class<T> t, Key<TK> k) throws IsamException, RecordException {
        List<T> res = new ArrayList<T>();
        IsamResult<T> isamres = isam.readLT(t, k);
        while(isamres.read()) {
            res.add(isamres.current());
        }
        isamres.close();
        return res;
    }
}
