package dk.vajhoej.isam.local;

import java.util.HashMap;
import java.util.Map;

import dk.vajhoej.record.CodeGen;
import dk.vajhoej.record.FastStructReader;
import dk.vajhoej.record.FastStructWriter;
import dk.vajhoej.record.RecordException;

public class FastSupport {
	private static Map<Class<?>,FastStructWriter<?>> writer = new HashMap<Class<?>,FastStructWriter<?>>();
	private static Map<Class<?>,FastStructReader<?>> reader = new HashMap<Class<?>,FastStructReader<?>>();
	static <T> FastStructWriter<T> getWriter(Class<T> t) throws RecordException {
		@SuppressWarnings("unchecked")
		FastStructWriter<T> fsw = (FastStructWriter<T>)writer.get(t);
		if(fsw == null) {
			fsw = CodeGen.genWriter(t);
			writer.put(t,  fsw);
		}
		return fsw;
	}
	static <T> FastStructReader<T> getReader(Class<T> t) throws RecordException {
		@SuppressWarnings("unchecked")
		FastStructReader<T> fsr = (FastStructReader<T>)reader.get(t);
		if(fsr == null) {
			fsr = CodeGen.genReader(t);
			reader.put(t,  fsr);
		}
		return fsr;
	}
}
